

/*
 * Tractament i publicació d'imatge i vídeo
 * Rosa Suñé Barniol
 * Pràctica 2 - Exercici 4
 * Aplicar màscara de convolució de tipus Sobel 
 * al vídeo Suñé_Rosa_B_1
 * Imoportar els fotogrames del vídeo 
 * Exportar els fotogrames per tornar a muntar el vídeo
 */
//matriu de Sobel per la direcció x
float[][] sobel = {{-1, -2, -1}, 
                    { 0,  0,  0}, 
                    { 1,  2,  1}};
                    
PImage [] fotogrames;
PImage [] edgeImg;
int i;
int j;


void setup() { 
  size(640, 360);
   //carrego tots els fotogrames guardats en after effects a l'array fotogrames[i]
   fotogrames = new PImage[764];
   for(i=0; i<=764;i=i+1) {
   fotogrames[i] = loadImage("cartell_cine_"+i+".png");
}
  noLoop();//aturem el bucle perquè no es tornin a carregar
}

void draw() {
// Mostem l'array en el punt (0,0) 
image (fotogrames[i], 0, 0);
fotogrames[i].loadPixels();
  noLoop();

  //Anem a aplicar el filtre a cada fotograma
  // Creem una imatge opaca de la mateixa mida que la original
  edgeImg = new PImage[764];
  edgeImg [j] = createImage(fotogrames[i].width, fotogrames[i].height, RGB);
  // Recorrem amb un bucle cada píxel de la imatge
  for (int y = 1; y < fotogrames[i].height-1; y++) { // No tenim en compte la fila de pixels 0 superior, no tenen pixel veí
    for (int x = 1; x < fotogrames[i].width-1; x++) { // No tenim en compte les columnes de pixels 0 dreta i esquerra, no tenen pixel veí
      float sum = 0; // Centre sum per cada pixel
      for (int ky = -1; ky <= 1; ky++) {
        for (int kx = -1; kx <= 1; kx++) {
          // Calculem els pixels adjacents per aquest pixel central
          int pos = (y + ky)*fotogrames[i].width + (x + kx);
          // La imatge és en escala de grisos red/green/blue són iguals
          float val = red(fotogrames[i].pixels[pos]);
          // Multipliquem pels pixels adjacents basats en el valor del pixel central
          sum += sobel[ky+1][kx+1] * val;
        }
      }
   // Li donem el valor de gris a aquest pixel de la nova imatge 
      // basat en la suma de valors del pixel central
      edgeImg[j].pixels[y*fotogrames[i].width + x] = color(sum, sum, sum);
    }
  }
  // Actualitzem els canvis a edgeImg.pixels[]
  edgeImg[j].updatePixels();
  image(edgeImg[j], 0, 0); //Dibuixem la nova imatge
  for(j=0; j<=764;j=j+1){
  save(j+"output-###.png");}//Guardem tota la seqüencia de fotogrames amb filtre sortints
}





  
  